/*************************************************************************
*
*	Function:  To show how to use events in C++.
*
*	Author:  Karl Riehl
*
*	Date:  May 2, 2005
*
*	Project:  Senior Capstone 2005 - Comm Port API
*
*************************************************************************/


#include <windows.h>
#include <iostream.h>

HANDLE _stdcall kr_OpenPort(char *port);
void _stdcall kr_ClosePort(HANDLE com);
int _stdcall kr_Read(HANDLE com, unsigned char * msg, int NumBytesToRead);
int _stdcall kr_Write(HANDLE com, unsigned char * msg, int NumBytesTorRead);

DWORD WINAPI TestThread( LPVOID lpParam ) 
{
	HANDLE com;
	com = (HANDLE)lpParam;

	OVERLAPPED o;
	
	unsigned char str[10];
	str[1] = '\0';


	// Needed to set mask for WaitCommEvent
	SetCommMask(com, EV_RXCHAR);

	// Creates an event for the OVERLAPPED structure
	o.hEvent = CreateEvent(
        NULL,   // default security attributes 
        FALSE,  // auto reset event 
        FALSE,  // not signaled 
        NULL    // no name
		);
    

    // Intialize the rest of the OVERLAPPED structure to zero.
    o.Internal = 0;
    o.InternalHigh = 0;
    o.Offset = 0;
    o.OffsetHigh = 0;

	
	DWORD dwEvtMask;

	int i;

	// Goes through and waits for event ten times and prints to screen
	for (int j=0; j < 10; j++)
	{
		WaitCommEvent(com, &dwEvtMask, &o);

		i = kr_Read(com, &str[0], 1);
		cout << "Wrote " << str << " in the thread" << endl;
	}

	return 1;
}

int main()
{
	HANDLE com;
	unsigned char msg[2];

	// Needed to print out on screen
	msg[1] = '\0';
	

	// Opens port
	com = kr_OpenPort("COM1");

	// Creates array of threads for Event
	HANDLE thd[1];
	DWORD dwthd;

	// Creates Thread
	thd[0] = CreateThread(NULL, 0, TestThread, com, 0, &dwthd);

	// Initialize array
	msg[0] = 'a';

	// Goes through 10 times and increases the letter by one each time
	for (int i = 0; i < 10; i++)
	{
		kr_Write(com, &msg[0], 1);
		cout << "Wrote " << msg << " in the main" << endl;
		Sleep(1000);
		msg[0]++;
	}

	// Waits for the thread to finish
	WaitForMultipleObjects(1, thd, true, INFINITE);
	
	kr_ClosePort(com);
		
	return 1;
}

